program PMF_To_CueSheet;

uses crt,dos;

var PMFFile,Track1File,
    Track2File, Track3File      : file;
    CueFile,FormatFile          : text;
    name                        : string;
    NumTracks                   : byte;
    lba        : array[1..3] of byte;
    c1,c2,c3   : byte;
    track                       : array[1..3] of record
                                                       mode  : byte;
                                                       start : longint;
                                                       stop  : longint;
                                                       size  : longint;
                                                  end;

procedure init;
var s,n    : string;
    b      : byte;

begin
     writeln(' PMF-To-Track   V 1.0');
     writeln;
     writeln;
     s:=paramstr(1);
     name:=s;
     n:=s+'.pmf';
     Writeln('ffne PMF-File : ',n);
     assign(PMFFile,n);
     reset(PMFFile,1);
     n:=s+'.ff';
     writeln('ffne FF-File : ',n);
     assign(FormatFile,n);
     reset(FormatFile);
     n:=s+'.cue';
     writeln('ffne Cue-File : ',n);
     assign(CueFile,n);
     rewrite(CueFile);
     n:=s+'1.trk';
     writeln('ffne Track1-File : ',n);
     assign(Track1File,n);
     rewrite(Track1File,1);
     n:=s+'2.trk';
     writeln('ffne Track2-File : ',n);
     assign(Track2File,n);
     rewrite(Track2File,1);
     n:=s+'3.trk';
     writeln('ffne Track3-File : ',n);
     assign(Track3File,n);
     rewrite(Track3File,1);
     for b:=1 to 3 do
     begin
          track[b].mode:=0;
          track[b].start:=0;
          track[b].stop:=0;
          track[b].size:=0;
     end;

end;

procedure CloseAll;
begin
     Writeln;
     write('Schliee alle Files ... ');
     close(PMFFile);
     close(FormatFile);
     close(CueFile);
     close(Track1File);
     close(Track2File);
     close(Track3File);
     writeln('OK !');
end;

procedure DisplayHelp;
begin
     writeln('PMF-To-CueSheet  V 1.0');
     writeln;
     writeln('Aufruf:  PMF2CUE <PMF-filename without extension> ');
     writeln;
     writeln('(c) Alexander');
end;

procedure GetFileFormat;
var       b,c : byte;
          s,n,a : string;
          l     : longint;
          error : integer;
begin
     { Read the info from the .FF file }
     writeln;
     for b:=1 to 9 do
     begin
         readln(FormatFile,s);
         writeln(s);
     end;
     readln(FormatFile,s);
     writeln(s);
     NumTracks:=ord(s[length(s)])-48;
     readln(FormatFile,s);
     writeln(s);
     for c:=1 to NumTracks do
     begin
          readln(FormatFile,s);
          writeln(s);
          n:=copy(s,5,length(s)-4);
          b:=pos(' ',n);
          a:=copy(n,1,b-1);
          val(a,l,error);
          track[c].mode:=ord(s[3])-48;
          track[c].start:=l;
          a:=copy(n,b+1,length(s));
          val(a,l,error);
          track[c].stop:=l;
          track[c].size:=track[c].stop-track[c].start;
     end;
end;

procedure CountDummyGAP(g : byte);
var i : byte;
begin
     i:=0;
     repeat
           inc(i);
           inc(lba[3]);
           inc(c1);
           if c1=11 then
           begin
                inc(lba[3],6);
                c1:=1;
           end;
           if lba[3]>116 then
           begin
                inc(lba[2]);
                lba[3]:=0;
                c1:=1;
                inc(c2);
           end;
           if c2=11 then
           begin
                inc(lba[2],6);
                c2:=1;
           end;
           if lba[2]>89 then
           begin
                inc(lba[1]);
                lba[2]:=0;
                c2:=1;
                inc(c3);
           end;
     until i=g;
end;

procedure WriteTrack1;
const bufsize = 20560; { 10 * 2056 Sector size for PMF-File }
type tbuf = array[0..bufsize-1] of byte;
var       buf    : ^tbuf;
          bufout : array[1..2352] of byte;
          result,r   : word;
          b,x,y      : byte;
          l,fp,w     : longint;
          ende       : boolean;
begin
     l:=-1;
     w:=0;
     new(buf);
     fillchar(bufout,2352,chr($00));
     bufout[1]:=$0;
     fillchar(bufout[2],10,chr(255));
     bufout[16]:=$02;
     write('Track1 : Sektor ');
     x:=wherex;
     y:=wherey;
     seek(pmffile,0);
     c1:=0;
     c2:=0;
     c3:=0;
     lba[1]:=0;
     lba[2]:=2;
     lba[3]:=255;
     repeat
       blockread(PMFFile,buf^,bufsize,result);
       b:=1;
       fp:=filepos(pmffile);
       while (w <= track[1].size) and (b<=10) do
       begin
            move(buf^[(b-1)*2056],bufout[17],2056);
            { Update block adress in header }
            inc(lba[3]);
            inc(c1);
            if c1=11 then
            begin
                 inc(lba[3],6);
                 c1:=1;
            end;
            if lba[3]>116 then
            begin
                 inc(lba[2]);
                 lba[3]:=0;
                 c1:=1;
                 inc(c2);
            end;
            if c2=11 then
            begin
                 inc(lba[2],6);
                 c2:=1;
            end;
            if lba[2]>89 then
            begin
                 inc(lba[1]);
                 lba[2]:=0;
                 c2:=1;
                 inc(c3);
            end;
            bufout[13]:=lba[1];
            bufout[14]:=lba[2];
            bufout[15]:=lba[3];
            blockwrite(Track1File,bufout,2352,r);
            inc(l);
            inc(b);
            inc(w);
            gotoxy(x,y);write(l);
       end;
     until w>=track[1].size;
     writeln;
     CountDummyGAP(152);
end;

procedure WriteTrack2;
const bufsize = 20560; { 10 * 2056 Sector size for PMF-File }
type tbuf = array[0..bufsize-1] of byte;
var       buf    : ^tbuf;
          bufout : array[1..2352] of byte;
          result,r   : word;
          b,x,y      : byte;
          l,w,fp       : longint;
          ende       : boolean;

begin
     l:=-1;
     w:=0;
     new(buf);
     fillchar(bufout,2352,chr($00));
     bufout[1]:=$0;
     fillchar(bufout[2],10,chr(255));
     bufout[16]:=$02;
     write('Track2 : Sektor ');
     x:=wherex;
     y:=wherey;
     seek(pmffile,(track[1].size+1)*2056);
     repeat
       blockread(PMFFile,buf^,bufsize,result);
       b:=1;
       fp:=filepos(pmffile);
       while (w <= track[2].size) and (b<=10) do
       begin
            move(buf^[(b-1)*2056],bufout[17],2056);
            { Update block adress in header }
            inc(lba[3]);
            inc(c1);
            if c1=11 then
            begin
                 inc(lba[3],6);
                 c1:=1;
            end;
            if lba[3]>116 then
            begin
                 inc(lba[2]);
                 lba[3]:=0;
                 c1:=1;
                 inc(c2);
            end;
            if c2=11 then
            begin
                 inc(lba[2],6);
                 c2:=1;
            end;
            if lba[2]>89 then
            begin
                 inc(lba[1]);
                 lba[2]:=0;
                 c2:=1;
                 inc(c3);
            end;
            bufout[13]:=lba[1];
            bufout[14]:=lba[2];
            bufout[15]:=lba[3];
            blockwrite(Track2File,bufout,2352,r);
            inc(l);
            inc(b);
            inc(w);
            gotoxy(x,y);write(l);
       end;
     until w>=track[2].size;
     writeln;
     CountDummyGAP(152);
end;

procedure WriteTrack3;
const bufsize = 20560; { 10 * 2056 Sector size for PMF-File }
type tbuf = array[0..bufsize-1] of byte;
var       buf    : ^tbuf;
          bufout : array[1..2352] of byte;
          result,r   : word;
          b,x,y      : byte;
          l,fp,w     : longint;
          lba        : array[1..3] of byte;
          c1,c2,c3   : byte;
          ende       : boolean;

begin
     l:=-1;
     w:=0;
     new(buf);
     fillchar(bufout,2352,chr($00));
     bufout[1]:=$0;
     fillchar(bufout[2],10,chr(255));
     bufout[16]:=$02;
     write('Track3 : Sektor ');
     x:=wherex;
     y:=wherey;
     seek(pmffile,(track[2].size+track[1].size+2)*2056);
     repeat
       blockread(PMFFile,buf^,bufsize,result);
       b:=1;
       fp:=filepos(pmffile);
       while (w <= track[3].size) and (b<=10) do
       begin
            move(buf^[(b-1)*2056],bufout[17],2056);
            { Update block adress in header }
            inc(lba[3]);
            inc(c1);
            if c1=11 then
            begin
                 inc(lba[3],6);
                 c1:=1;
            end;
            if lba[3]>116 then
            begin
                 inc(lba[2]);
                 lba[3]:=0;
                 c1:=1;
                 inc(c2);
            end;
            if c2=11 then
            begin
                 inc(lba[2],6);
                 c2:=1;
            end;
            if lba[2]>89 then
            begin
                 inc(lba[1]);
                 lba[2]:=0;
                 c2:=1;
                 inc(c3);
            end;
            bufout[13]:=lba[1];
            bufout[14]:=lba[2];
            bufout[15]:=lba[3];
            blockwrite(Track3File,bufout,2352,r);
            inc(l);
            inc(b);
            inc(w);
            gotoxy(x,y);write(l);
       end;
     until w>=track[3].size;
     writeln;
end;

procedure GenerateCueFile;
begin
     writeln;
     writeln('Generating CueSheet File');
     writeln(CueFile,'FILE '+name+'1.trk BINARY');
     writeln(CueFile,'  TRACK 01 Mode2/2352');
     writeln(CueFile,'    INDEX 01 00:00:00');
     writeln(CueFile,'  POSTGAP 00:02:02');
     writeln(CueFile);
     writeln(CueFile,'FILE '+name+'2.trk BINARY');
     writeln(CueFile,'  TRACK 02 Mode2/2352');
     writeln(CueFile,'    INDEX 01 00:00:00');
     writeln(CueFile,'  POSTGAP 00:02:02');
     writeln(CueFile);
     writeln(CueFile,'FILE '+name+'3.trk BINARY');
     writeln(CueFile,'  TRACK 03 Mode2/2352');
     writeln(CueFile,'    INDEX 01 00:00:00');
     writeln(CueFile,'  POSTGAP 00:02:02');
     writeln(CueFile);
end;


{ Main Core }

begin
     if paramcount=0 then
     begin
          DisplayHelp;
          halt;
     end;
     init;
     GetFileFormat;
     WriteTrack1;
     WriteTrack2;
     WriteTrack3;
     GenerateCueFile;

     CloseAll;
end.

